﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace CSharpSamples_Khoshamoz.Samples
{
    public partial class FrmSample030 : Form
    {
        public FrmSample030()
        {
            InitializeComponent();
        }

        private void btnDo_Click(object sender, EventArgs e)
        {
            OOP.Scoreboard sb = new OOP.Scoreboard();
            OOP.Scoreboard.GetScore getScore = new OOP.Scoreboard.GetScore(sb.CalculateAdultScore);

            if (rdoAdult.Checked == true)
            {
                getScore = new OOP.Scoreboard.GetScore(sb.CalculateAdultScore);
            }
            else
            {
                getScore = new OOP.Scoreboard.GetScore(sb.CalculateChildScore);
            }

            int second = 0;
            int target = 0;
            int.TryParse(txtSecond.Text, out second);
            int.TryParse(txtTarget.Text, out target);

            int result = getScore(second, target);
            lblResult.Text = result.ToString();
        }

        private void TargitHit()
        {
            lblResult.Text +="\n" + "توپ به هدف خورد";
        }

        private void PointsAwarded()
        {
            lblResult.Text +="\n" + "امتیازها اعطا شدند";
        }

        private void ShowMsg()
        {
            lblResult.Text +="\n" + "کارت عالی بود";
        }

        private delegate void ShowStatus();

        private void btnTestMulticastingDelegate_Click(object sender, EventArgs e)
        {
            ShowStatus Hit = new ShowStatus(this.TargitHit);
            ShowStatus Pints = new ShowStatus(this.PointsAwarded);
            ShowStatus Msg = new ShowStatus(this.ShowMsg);

            ShowStatus display = Hit;
            display += Msg;
            display += Pints;

            display();
        }




    }
}
